#include <gccore.h>
#include <ogcsys.h>
#include <wiiuse/wpad.h>

PADStatus pad[4];
u16 new_pad=0, old_pad=0, now_pad=0;

void readpad(void)
{
	static int n=0, X, Y;
	struct expansion_t ext;
	
	u16 tmp;
	u32 WiiPad;
	PAD_Read(pad);
	
	
	// Wiimote support
	WPAD_ScanPads();
	WiiPad = WPAD_ButtonsHeld(0);
	if (WiiPad & WPAD_BUTTON_UP)    { pad[0].button |= PAD_BUTTON_LEFT;       }         
	if (WiiPad & WPAD_BUTTON_DOWN)  { pad[0].button |= PAD_BUTTON_RIGHT;      }       
	if (WiiPad & WPAD_BUTTON_LEFT)  { pad[0].button |= PAD_BUTTON_DOWN;       }       
	if (WiiPad & WPAD_BUTTON_RIGHT) { pad[0].button |= PAD_BUTTON_UP;         }    
	if (WiiPad & WPAD_BUTTON_2)     { pad[0].button |= PAD_BUTTON_A;          }       
	if (WiiPad & WPAD_BUTTON_1)     { pad[0].button |= PAD_BUTTON_B;          }
	if (WiiPad & WPAD_BUTTON_HOME)  { pad[0].button |= PAD_TRIGGER_L;         }
	if (WiiPad & WPAD_BUTTON_B)     { pad[0].button |= PAD_TRIGGER_Z;         }	  
	if (WiiPad & WPAD_BUTTON_A)     { pad[0].button |= PAD_BUTTON_START ;     }  
	if (WiiPad & WPAD_BUTTON_PLUS)  { pad[0].button |= PAD_TRIGGER_R;         }
	
	WPAD_Expansion(WPAD_CHAN_0, &ext);
	if (ext.type == WPAD_EXP_CLASSIC)
	{
		if (WiiPad & WPAD_CLASSIC_BUTTON_UP)    { pad[0].button |= PAD_BUTTON_UP;         }         
		if (WiiPad & WPAD_CLASSIC_BUTTON_DOWN)  { pad[0].button |= PAD_BUTTON_DOWN;       }       
		if (WiiPad & WPAD_CLASSIC_BUTTON_LEFT)  { pad[0].button |= PAD_BUTTON_LEFT;       }       
		if (WiiPad & WPAD_CLASSIC_BUTTON_RIGHT) { pad[0].button |= PAD_BUTTON_RIGHT;      }    
		if (WiiPad & WPAD_CLASSIC_BUTTON_HOME)  { pad[0].button |= PAD_TRIGGER_L;         }
		if (WiiPad & WPAD_CLASSIC_BUTTON_MINUS) { pad[0].button |= PAD_TRIGGER_Z;         }	  
		if (WiiPad & WPAD_CLASSIC_BUTTON_PLUS)  { pad[0].button |= PAD_BUTTON_START ;     }   
		if (WiiPad & WPAD_CLASSIC_BUTTON_A)     { pad[0].button |= PAD_BUTTON_A;          }
		if (WiiPad & WPAD_CLASSIC_BUTTON_B)     { pad[0].button |= PAD_BUTTON_B;          }
		if (WiiPad & WPAD_CLASSIC_BUTTON_Y)     { pad[0].button |= PAD_BUTTON_A;          }
		if (WiiPad & WPAD_CLASSIC_BUTTON_X)     { pad[0].button |= PAD_BUTTON_B;          }
		if (WiiPad & WPAD_CLASSIC_BUTTON_ZL)    { pad[0].button |= PAD_TRIGGER_R;         }
		if (WiiPad & WPAD_CLASSIC_BUTTON_ZR)    { pad[0].button |= PAD_TRIGGER_R;         }
		
		X =   ((ext.classic.ljs.pos.x - ext.classic.ljs.center.x) * 200 / (ext.classic.ljs.max.x - ext.classic.ljs.min.x));
		Y = - ((ext.classic.ljs.pos.y - ext.classic.ljs.center.y) * 200 / (ext.classic.ljs.max.y - ext.classic.ljs.min.y));
		if (X < -50) { pad[0].button |= PAD_BUTTON_LEFT; }
		if (X >  50) { pad[0].button |= PAD_BUTTON_RIGHT;}
		if (Y < -50) { pad[0].button |= PAD_BUTTON_UP;   }
		if (Y >  50) { pad[0].button |= PAD_BUTTON_DOWN; }
	}
	
	
	tmp = now_pad = pad[0].button;
	// kmg
	// Analog pad state
	if (pad[0].stickY < -65) tmp |= PAD_BUTTON_DOWN;  // DOWN
	if (pad[0].stickY >  65) tmp |= PAD_BUTTON_UP;    // UP
	if (pad[0].stickX < -65) tmp |= PAD_BUTTON_LEFT;  // LEFT
	if (pad[0].stickX >  65) tmp |= PAD_BUTTON_RIGHT; // RIGH

	new_pad = tmp & ~old_pad;
	if(old_pad==tmp){
		n++;
		if(n>=25){
			new_pad = tmp;
			n = 20;
		}
	}else{
		n=0;
		old_pad = tmp;
	}
	
	
}
